MyDPS = LibStub("AceAddon-3.0"):NewAddon("MyDPS", "AceEvent-3.0");
MyDPS.dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("MyDPS", {type = "data source", icon = "Interface\\Icons\\Ability_DualWield", text = "MyDPS"})

--------------------------------------------------------------------------

function MyDPS:OnInitialize()

	MyDPS.collecting = false;
	MyDPS.startTime = nil;
	MyDPS.endTime = nil;
	MyDPS.damageDone = 0;

end

--------------------------------------------------------------------------

function MyDPS:OnEnable()

	MyDPS:RegisterEvent("UNIT_PET");
	MyDPS:RegisterEvent("UNIT_ENTERED_VEHICLE");
	MyDPS:RegisterEvent("UNIT_EXITED_VEHICLE");
	MyDPS:RegisterEvent("PLAYER_REGEN_DISABLED");
	MyDPS:RegisterEvent("PLAYER_REGEN_ENABLED");
	MyDPS:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	
	MyDPS.playerGUID = UnitGUID("player");
	MyDPS.petGUID = UnitGUID("playerpet");
	MyDPS.vehicleGUID = UnitGUID("vehicle");

end

--------------------------------------------------------------------------

function MyDPS:OnDisable()

	MyDPS:UnregisterEvent("UNIT_PET");
	MyDPS:UnregisterEvent("UNIT_ENTERED_VEHICLE");
	MyDPS:UnregisterEvent("UNIT_EXITED_VEHICLE");
	MyDPS:UnregisterEvent("PLAYER_REGEN_DISABLED");
	MyDPS:UnregisterEvent("PLAYER_REGEN_ENABLED");
	MyDPS:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	
	MyDPS.collecting = false;

end

--------------------------------------------------------------------------

function MyDPS:UpdateDisplay()

	if (MyDPS.startTime ~= nil) then
		
		local duration = 1;
		
		if ((MyDPS.lastTime - MyDPS.startTime) > 1) then
		
			duration = MyDPS.lastTime - MyDPS.startTime;
			
		end
	
		MyDPS.dataobj.text = string.format("%.1f", MyDPS.damageDone / duration);
	
	else
	
		MyDPS.dataobj.text = "MyDPS";
	
	end

end

--------------------------------------------------------------------------

function MyDPS:UNIT_PET(_, unit)

	if (unit == "player") then

		MyDPS.petGUID = UnitGUID("playerpet");
		
	end

end

--------------------------------------------------------------------------

function MyDPS:UNIT_ENTERED_VEHICLE(_, unit)

	if (unit == "player") then
	
		MyDPS.vehicleGUID = UnitGUID("vehicle");
		
	end

end

--------------------------------------------------------------------------

function MyDPS:UNIT_EXITED_VEHICLE(_, unit)

	if (unit == "player") then
	
		MyDPS.vehicleGUID = nil;
		
	end

end

--------------------------------------------------------------------------

function MyDPS:PLAYER_REGEN_ENABLED()

	-- leaving combat
	MyDPS.collecting = false;
	
	MyDPS:UpdateDisplay();

end

--------------------------------------------------------------------------

function MyDPS:PLAYER_REGEN_DISABLED()

	-- entering combat
	MyDPS.collecting = true;
	MyDPS.startTime = nil;
	MyDPS.lastTime = nil;
	MyDPS.damageDone = 0;
	
	MyDPS:UpdateDisplay();

end

--------------------------------------------------------------------------

function MyDPS:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, srcGuid, _, _, destGuid, _, _, param1, param2, param3, param4, param5, param6, param7, param8)

	if ( MyDPS.collecting and (srcGuid == MyDPS.playerGUID or srcGuid == MyDPS.petGUID or srcGuid == MyDPS.vehicleGUID)) then
	
		if ( event == "SWING_DAMAGE" ) then
		
			MyDPS.damageDone = MyDPS.damageDone + param1;
			
			MyDPS.lastTime = GetTime();
			if (MyDPS.startTime == nil) then
			
				MyDPS.startTime = GetTime();
				
			end
			
			MyDPS:UpdateDisplay();
		
		elseif ( event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" ) then
		
			MyDPS.damageDone = MyDPS.damageDone + param4;

			MyDPS.lastTime = GetTime();
			if (MyDPS.startTime == nil) then
			
				MyDPS.startTime = GetTime();
				
			end
			
			MyDPS:UpdateDisplay();
		
		end
	
	end

end
